package net.maunium.bukkit.InfoSigns.Commands;

import net.maunium.bukkit.InfoSigns.InfoSigns;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;

public class InfoModify implements CommandExecutor {
	
	InfoSigns plugin;
	
	public InfoModify(InfoSigns plugin){
		this.plugin = plugin;
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label,
			String[] args) {
		if(cmd.getName().equalsIgnoreCase("infomodify")){
			if(args.length > 2){
				int i2;
				try{
					i2 = Integer.parseInt(args[1]);
				} catch (NumberFormatException e){
					sender.sendMessage(plugin.errtag + "The second argument must be a number between 1 and 10.");
					return true;
				}
				if(i2 < 1 || i2 > 10){
					sender.sendMessage(plugin.errtag + "The second argument must be a number between 1 and 10.");
					return true;
				}
				if(plugin.infotags.containsKey(args[0])){
					if(sender.hasPermission("infosigns.modify.others")){
						String text = "";
						for(int i = 2; i < args.length; i++){
							if(text == ""){
								text = args[i];
							} else {
								text = text + " " + args[i];
							}
						}
						if(sender.hasPermission("infosigns.colors")){
							text = text.replaceAll("&", "");
						}
						plugin.setTagText(args[0], Integer.parseInt(args[1]), text);
						sender.sendMessage(plugin.stag + "Modified " + args[0] + " row #" + args[1] + ". New text: " + text);
					} else if (sender.hasPermission("infosigns.modify")){
						if(plugin.infotags.get(args[0]).getOwner().equalsIgnoreCase(sender.getName())){
							String text = "";
							for(int i = 2; i < args.length; i++){
								if(text == ""){
									text = args[i];
								} else {
									text = text + " " + args[i];
								}
							}
							if(sender.hasPermission("infosigns.colors")){
								text = text.replaceAll("&", "");
							}
							plugin.setTagText(args[0], Integer.parseInt(args[1]), text);
							sender.sendMessage(plugin.stag + "Modified " + args[0] + " row #" + args[1] + ". New text: " + text);
						} else {
							sender.sendMessage(plugin.errtag + "That is not your own InfoTag. You can only modify your own infotags.");
						}
					} else {
						sender.sendMessage(plugin.errtag + "You do not have the permissions to modify InfoTags.");
					}
				} else {
					sender.sendMessage(plugin.errtag + "There is no InfoTag called " + args[0] + ".");
				}
			} else {
				sender.sendMessage(plugin.errtag + "Usage: /infomodify <InfoTag> <Row> <Text>");
			}
			return true;
		}
		return false;
	}
}
