package net.maunium.bukkit.Mau1v1;

import java.util.Arrays;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.plugin.java.JavaPlugin;

import net.maunium.bukkit.Maussentials.Utils.I18n;
import net.maunium.bukkit.Maussentials.Utils.I18n.I15r;
import net.maunium.bukkit.Maussentials.Utils.SerializableLocation;

public class Mau1v1 extends JavaPlugin implements I15r {
	public String version;
	public final String stag = ChatColor.DARK_GREEN + "[" + ChatColor.GREEN + "Mau1v1" + ChatColor.DARK_GREEN + "] " + ChatColor.GRAY,
			errtag = ChatColor.DARK_RED + "[" + ChatColor.RED + "Mau1v1" + ChatColor.DARK_RED + "] " + ChatColor.RED;
	private I18n i18n;
	private Location spawn, lobby, arenaS1, arenaS2;
	
	@Override
	public void onEnable() {
		long st = System.currentTimeMillis();
		version = getDescription().getVersion();
		saveDefaultConfig();
		
		getCommand("mau1v1").setExecutor(new Command1v1(this));
		
		spawn = getServer().getWorlds().get(0).getSpawnLocation();
		lobby = ((SerializableLocation) getConfig().get("location.lobby", new SerializableLocation(spawn))).toLocation();
		arenaS1 = ((SerializableLocation) getConfig().get("location.arena.spawn1", new SerializableLocation(spawn))).toLocation();
		arenaS2 = ((SerializableLocation) getConfig().get("location.arena.spawn2", new SerializableLocation(spawn))).toLocation();
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info("Mau1v1 v" + version + " by Tulir293 enabled in " + et + "ms.");
	}
	
	@Override
	public void onDisable() {
		long st = System.currentTimeMillis();
		
		// TODO: Disable code
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info("Mau1v1 v" + version + " by Tulir293 disabled in " + et + "ms.");
	}
	
	@Override
	public String translate(String node, Object... replace) {
		return i18n.translate(node, replace);
	}
	
	public ItemStack getChallengeItem() {
		ItemStack i = new ItemStack(Material.EMERALD, 1);
		ItemMeta im = i.getItemMeta();
		im.setDisplayName(translate("item.challenge.name"));
		im.setLore(Arrays.asList(translate("item.challenge.lore")));
		return i;
	}
	
	public Location get1v1Lobby() {
		return lobby;
	}
	
	public Location getSpawn1() {
		return arenaS1;
	}
	
	public Location getSpawn2() {
		return arenaS2;
	}
}