package net.maunium.bukkit.Mau1v1;

import java.util.ArrayList;
import java.util.List;

import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.entity.Player;
import org.bukkit.metadata.FixedMetadataValue;
import org.bukkit.metadata.MetadataValue;
import org.bukkit.plugin.java.JavaPlugin;

public class Mau1v1 extends JavaPlugin{
	
	protected String version, name, author, errtag, stag;
	protected List<Arena> arenas;
	protected Mau1v1Manager man;
	public static final String
	CHALLENGER = "ehKO6-1v1Challenger",
	OPPONENT = "94n1A-1v1Opponent",
	NOMOVE = "I4ty5-1v1NoMove",
	PVPING = "Yg5vR-1v1PvPing",
	ARENA = "cz3vT-1v1Arena";
	
	@Override
	public void onEnable(){
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		name = this.getDescription().getName();
		author = this.getDescription().getAuthors().get(0);
		stag = "2[a" + name + "2]7 ";
		errtag = "4[c" + name + "4]c ";
		this.saveDefaultConfig();
		
		man = new Mau1v1Manager(this);
		
		this.getCommand("1v1").setExecutor(new Command1v1(this));
		this.getCommand("1v1admin").setExecutor(new Command1v1Admin(this));
		this.getServer().getPluginManager().registerEvents(new PlayerDeathListener(this), this);
		this.getServer().getPluginManager().registerEvents(new PlayerQuitListener(this), this);
		this.getServer().getPluginManager().registerEvents(new PlayerMoveListener(this), this);
		this.getServer().getPluginManager().registerEvents(new PlayerCommandListener(this), this);
		this.arenas = new ArrayList<Arena>();
		
		int amountOfArenas = getConfig().getInt("amount-of-arenas");
		for(int i = 0; i < amountOfArenas; i++){
			String cs = "arenas." + i + ".";
			arenas.add(new Arena(i, getAndParse(cs + "spawn-1"), getAndParse(cs + "spawn-2")));
		}
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + et + "ms.");
	}
	@Override
	public void onDisable(){
		long st = System.currentTimeMillis();
		
		int i = 0;
		for(Arena a : arenas){
			String cs = "arenas." + i + ".";
			getConfig().set(cs + "spawn-1", locToString(a.getSpawn1()));
			getConfig().set(cs + "spawn-2", locToString(a.getSpawn2()));
			i++;
		}
		getConfig().set("amount-of-arenas", i + 1);
		this.saveConfig();
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " disabled in " + et + "ms.");
	}
	
	protected Location getAndParse(String s){
		return parseLocation(getConfig().getString(s));
	}
	protected Location parseLocation(String s) throws NumberFormatException, NullPointerException{
		if(s.equalsIgnoreCase("null")) return null;
		String[] temp = s.split(", ");
		double x, y, z;
		float yaw, pitch;
		World w;
		try{
			x = Double.parseDouble(temp[0]);
			y = Double.parseDouble(temp[1]);
			z = Double.parseDouble(temp[2]);
			yaw = Float.parseFloat(temp[3]);
			pitch = Float.parseFloat(temp[4]);
		} catch (NumberFormatException e){
			throw new NumberFormatException();
		} catch (NullPointerException e){
			throw new NullPointerException();
		}
		
		if(getServer().getWorld(temp[5]) != null){
			w = getServer().getWorld(temp[5]);
		} else {
			return null;
		}
		return new Location(w, x, y, z, yaw, pitch);
	}
	protected String locToString(Location l){
		String s = l.getX() + ", " + l.getY() + ", " + l.getZ() + ", " + l.getYaw() + ", " + l.getPitch() + ", " + l.getWorld().getName();
		return s;
	}
	public MetadataValue getMetadata(Player from, String key){
		List<MetadataValue> metadata = from.getMetadata(key);
		for(MetadataValue mv : metadata){
			if(mv.getOwningPlugin().equals(this)){
				return mv;
			}
		}
		return null;
	}
	public boolean hasMetadata(Player check, String key){
		if(check.hasMetadata(key)){
			List<MetadataValue> metadata = check.getMetadata(key);
			for(MetadataValue mv : metadata){
				if(mv.getOwningPlugin().equals(this)){
					return true;
				}
			}
		}
		return false;
	}
	public void setMetadata(Player to, String key, Object value){
		to.setMetadata(key, new FixedMetadataValue(this, value));
	}
	public void removeMetadata(Player from, String key){
		from.removeMetadata(key, this);
	}
	public Player getPlayer(String name){
		for(Player p : this.getServer().getOnlinePlayers()){
			if(p.getName().equalsIgnoreCase(name)){
				return p;
			}
		}
		return null;
	}
}
