package net.maunium.bukkit.MauBans.CommandExecutors;

import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;

import net.maunium.bukkit.MauBans.MauBans;
import net.maunium.bukkit.MauBukLib.MauUtils;

public class CommandBan implements CommandExecutor {
	private MauBans plugin;
	
	public CommandBan(MauBans plugin) {
		this.plugin = plugin;
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (args.length == 1) {
			sender.sendMessage(plugin.errtag + plugin.format("error.banreason"));
			return true;
		} else if (args.length > 1) {
			OfflinePlayer p = MauUtils.getOfflinePlayer(args[0]);
			if(p == null){
				sender.sendMessage(plugin.errtag + plugin.format("error.nevervisited", args[0]));
				return true;
			}
			StringBuffer sb = new StringBuffer();
			for (int i = 1; i < args.length; i++) {
				sb.append(args[i]);
				sb.append(" ");
			}
			sb.deleteCharAt(sb.length() - 1);
			String reason = sb.toString();
			plugin.ban(p.getUniqueId(), p.getName(), sender.getName(), reason);
			
			boolean silent = plugin.v.isVanished(sender);
			if(reason.endsWith(" silent")){
				reason = reason.substring(reason.length() - 7, reason.length());
				silent = true;
			}
			
			if(!silent) plugin.getServer().broadcast(plugin.format("broadcast.banned", p.getName(), reason, sender.getName()), "maubans.see.ban");
			return true;
		}
		return false;
	}
}
