package net.maunium.bukkit.MBR;

import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.bukkit.Material;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.plugin.java.JavaPlugin;

public class MBR extends JavaPlugin implements Listener{
	
	private String version, name, author;
	private Map<String, Set<Material>> blockedMaterials = new HashMap<String, Set<Material>>();
	private Map<String, String> messages = new HashMap<String, String>();
	
	@Override
	public void onEnable(){
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		name = this.getDescription().getName();
		author = this.getDescription().getAuthors().get(0);
		this.saveDefaultConfig();		
		this.getServer().getPluginManager().registerEvents(this, this);
		
		ConfigurationSection cs = this.getConfig().getConfigurationSection("blocked-stuff");
		if(cs != null && cs.getValues(true) != null){
			for(Entry<String, Object> e : cs.getValues(true).entrySet()){
				getLogger().info("Reading blocked blocks world " + e.getKey());
				if(e.getValue() instanceof List){
					List<?> l = (List<?>) e.getValue();
					Set<Material> materials = new HashSet<Material>();
					for(Object o : l){
						Material m = Material.getMaterial(o.toString().toUpperCase());
						if(m != null){
							materials.add(m);
						} else {
							getLogger().warning("Material " + o.toString().toUpperCase() + " was not found!");
						}
					}
					blockedMaterials.put(e.getKey(), materials);
				} else {
					getLogger().warning("Error, " + e.getValue() + " is not a list! Skipping world " + e.getKey() + ".");
				}
			}
		}
		ConfigurationSection cs2 = this.getConfig().getConfigurationSection("messages");
		if(cs2 != null && cs2.getValues(true) != null){
			for(Entry<String, Object> e : cs2.getValues(true).entrySet()){
				getLogger().info("Message for " + e.getKey() + ": " + e.getValue());
				messages.put(e.getKey(), e.getValue().toString().replace("&", ""));
			}
		}
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + et + "ms.");
	}
	@Override
	public void onDisable(){
		long st = System.currentTimeMillis();
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " disabled in " + et + "ms.");
	}
	@EventHandler
	public void onBlockBreak(BlockBreakEvent evt){
		if(blockedMaterials.containsKey(evt.getBlock().getWorld().getName())){
			if(blockedMaterials.get(evt.getBlock().getWorld().getName()).contains(evt.getBlock().getType()) && !evt.getPlayer().hasPermission("mbr.bypass")){
				evt.setCancelled(true);
				evt.getPlayer().sendMessage(messages.get(evt.getBlock().getWorld().getName()));
			}
		}
	}
}