package net.maunium.bukkit.MauBukLib;

import org.bukkit.configuration.serialization.ConfigurationSerialization;
import org.bukkit.plugin.java.JavaPlugin;

/**
 * The main class of MauBukLib
 * 
 * @author Tulir293
 */
public class MauBukLib extends JavaPlugin {
	private String version = "1.0";
	private static MauBukLib instance;
	private static PlayerData pd;
	private static Utils utils = new Utils();
	
	@Override
	public void onEnable() {
		instance = this;
		version = this.getDescription().getVersion();
		ConfigurationSerialization.registerClass(Area.class);
		this.getServer().getPluginManager().registerEvents(new LoginListener(this), this);
		this.getServer().getPluginManager().registerEvents(new PreCommandListener(), this);
		pd = new PlayerData(this.getDataFolder());
	}
	
	@Override
	public void onDisable() {
		pd.close();
	}
	
	public String getVersion() {
		return version;
	}
	
	/**
	 * @deprecated Not used anywhere.
	 */
	@Deprecated
	public static MauBukLib getInstance() {
		return instance;
	}
	
	public static PlayerData getPlayerData() {
		return pd;
	}
	
	/**
	 * @deprecated Use the static methods in the MauUtils class.
	 */
	@Deprecated
	public static Utils getUtils() {
		return utils;
	}
}
