package net.maunium.bukkit.MauTracker;

import java.util.ArrayList;
import java.util.List;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import net.maunium.bukkit.MauBukLib.MauBukLib;

public class CommandTrack implements CommandExecutor {
	private MauTracker plugin;
	
	public CommandTrack(MauTracker plugin) {
		this.plugin = plugin;
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		Block mid;
		if (sender instanceof Player) mid = ((Player) sender).getLocation().getBlock().getRelative(BlockFace.DOWN);
		else {
			sender.sendMessage(plugin.errtag + plugin.format("error.onlyingame", label));
			return true;
		}
		Player p = (Player) sender;
		if (!p.hasPermission("mautracker.track")) {
			sender.sendMessage(plugin.errtag + plugin.format("error.permission"));
			return true;
		}
		Player igo = null;
		if (args.length > 0) {
			igo = MauBukLib.getUtils().getPlayer(args[0]);
		}
		if (mid.getType().equals(Material.DIAMOND_BLOCK)) {
			track(p, mid, Material.OBSIDIAN, Material.GOLD_BLOCK, 7000, igo);
			return true;
		} else if (mid.getType().equals(Material.GOLD_BLOCK)) {
			track(p, mid, Material.COAL_BLOCK, Material.IRON_BLOCK, 350, igo);
			return true;
		} else {
			p.sendMessage(plugin.errtag + plugin.format("error.notinmiddle"));
			return true;
		}
	}
	
	public void track(Player p, Block mid, Material arm, Material head, int max, Player ignoreOthers) {
		int north = getLength(mid, arm, head, BlockFace.NORTH);
		if (north == -1) {
			p.sendMessage(plugin.errtag + plugin.format("error.notvalidend", "North"));
			return;
		} else if (north > max) {
			north = max;
		}
		int east = getLength(mid, arm, head, BlockFace.EAST);
		if (east == -1) {
			p.sendMessage(plugin.errtag + plugin.format("error.notvalidend", "East"));
			return;
		} else if (east > max) {
			east = max;
		}
		int south = getLength(mid, arm, head, BlockFace.SOUTH);
		if (south == -1) {
			p.sendMessage(plugin.errtag + plugin.format("error.notvalidend", "South"));
			return;
		} else if (south > max) {
			south = max;
		}
		int west = getLength(mid, arm, head, BlockFace.WEST);
		if (west == -1) {
			p.sendMessage(plugin.errtag + plugin.format("error.notvalidend", "West"));
			return;
		} else if (west > max) {
			west = max;
		}
		StringBuffer n = new StringBuffer();
		StringBuffer w = new StringBuffer();
		StringBuffer s = new StringBuffer();
		StringBuffer e = new StringBuffer();
		for (Player p2 : getPlayers(mid.getLocation(), north, east, south, west)) {
			if (p2.getUniqueId().equals(p.getUniqueId())) continue;
			if (ignoreOthers != null) if (!p2.getUniqueId().equals(ignoreOthers.getUniqueId())) continue;
			
			int x = p2.getLocation().getBlockX() - mid.getLocation().getBlockX();
			int z = p2.getLocation().getBlockZ() - mid.getLocation().getBlockZ();
			if (z < 0 && z < x / 2) n.append(p2.getName() + ", ");
			if (x > 0 && x > z / 2) e.append(p2.getName() + ", ");
			if (z > 0 && z > x / 2) s.append(p2.getName() + ", ");
			if (x < 0 && x < z / 2) w.append(p2.getName() + ", ");
		}
		
		if(n.length() != 0) n.delete(n.length() - 2, n.length());
		if(w.length() != 0) w.delete(w.length() - 2, w.length());
		if(s.length() != 0) s.delete(s.length() - 2, s.length());
		if(e.length() != 0) e.delete(e.length() - 2, e.length());
		
		String nS = n.toString();
		String wS = w.toString();
		String sS = s.toString();
		String eS = e.toString();
		
		if(n.length() != 0) p.sendMessage(plugin.stag + plugin.format("message.playerloc", "North", north, nS));
		if(w.length() != 0) p.sendMessage(plugin.stag + plugin.format("message.playerloc", "West", west, wS));
		if(s.length() != 0) p.sendMessage(plugin.stag + plugin.format("message.playerloc", "South", south, sS));
		if(e.length() != 0) p.sendMessage(plugin.stag + plugin.format("message.playerloc", "East", east, eS));
		
		if(n.length() == 0 && w.length() == 0 && s.length() == 0 && e.length() == 0) p.sendMessage(plugin.stag + plugin.format("message.noplayers"));
	}
	
	private List<Player> getPlayers(Location l, int north, int east, int south, int west) {
		List<Player> rtrn = new ArrayList<Player>();
		for (Player p : plugin.getServer().getOnlinePlayers()) {
			int x = p.getLocation().getBlockX();
			int z = p.getLocation().getBlockZ();
			if (z > l.getBlockZ() - north && z < l.getBlockZ() + south && x > l.getBlockX() - west && x < l.getBlockX() + east) {
				rtrn.add(p);
			}
		}
		return rtrn;
	}
	
	private int getLength(Block mid, Material arm, Material end, BlockFace direction) {
		int length = 25;
		mid = mid.getRelative(direction);
		while (mid.getType().equals(arm)) {
			length += 25;
			mid = mid.getRelative(direction);
		}
		if (!mid.getType().equals(end)) { return -1; }
		return length;
	}
}
