package net.maunium.bukkit.MauPerms.Listeners;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.AsyncPlayerChatEvent;

import net.maunium.bukkit.MauBukLib.ChatFormatter;
import net.maunium.bukkit.MauPerms.Permissions.PermissionManager;

public class ChatListener implements Listener {
	@EventHandler(priority = EventPriority.LOWEST)
	public void onPlayerChat(AsyncPlayerChatEvent evt) {
		PermissionManager pm = PermissionManager.getInstance();
		String format = null;
		Player p = evt.getPlayer();
		format = pm.getPlayer(p.getUniqueId()).getChatFormat();
		
		if(!format.isEmpty()){
			format = format.replace("{PLAYER}", "%1$s");
			format = format.replace("{DISPLAYNAME}", p.getDisplayName());
			format = format.replace("{NICK}", pm.getPlayer(p.getUniqueId()).getNick());
			format = format.replace("{MESSAGE}", "%2$s");
			format = format.replace("{GROUP}", pm.getPlayer(p.getUniqueId()).getGroup());
			format = format.replace("{WORLD}", p.getWorld().getName());
			format = ChatFormatter.full(format);
			evt.setFormat(format);
		}
		
		if (evt.getPlayer().hasPermission("mauperms.chat.color")) evt.setMessage(ChatFormatter.color(evt.getMessage()));
		if (evt.getPlayer().hasPermission("mauperms.chat.format")) evt.setMessage(ChatFormatter.format(evt.getMessage()));
		if (evt.getPlayer().hasPermission("mauperms.chat.magic")) evt.setMessage(ChatFormatter.magic(evt.getMessage()));
	}
}
