package net.maunium.bukkit.MauPerms.Listeners;

import java.util.Map.Entry;

import org.bukkit.ChatColor;
import org.bukkit.entity.Player;

import net.maunium.bukkit.MauBukLib.MauBukLib;
import net.maunium.bukkit.MauPerms.MauPerms;
import net.maunium.bukkit.MauPerms.Permissions.GroupPerms;
import net.maunium.bukkit.MauPerms.Permissions.PermissionManager;
import net.maunium.bukkit.MauPerms.Permissions.PlayerPerms;

public class Commands {
	protected PermissionManager pm;
	protected MauPerms plugin;
	protected PlayerCmds pc;
	protected GroupCmds gc;
	
	protected Commands(MauPerms plugin) {
		this.pm = PermissionManager.getInstance();
		this.plugin = plugin;
		pc = new PlayerCmds();
		gc = new GroupCmds();
	}
	
	protected class GroupCmds {
		protected Add add;
		protected Del del;
		protected List list;
		
		protected GroupCmds() {
			add = new Add();
			del = new Del();
			list = new List();
		}
		
		protected class List {
			protected void perms(Player s, String cmd) {
				if (!s.hasPermission("mauperms.group.list.permissions")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					GroupPerms gp = pm.getGroup(args[0]);
					if (gp != null) {
						String perms = null;
						if (!gp.getPermissions().isEmpty()) {
							StringBuffer sb = new StringBuffer();
							for (Entry<String, Boolean> e : gp.getPermissions().entrySet())
								if (e.getValue()) sb.append(ChatColor.YELLOW + e.getKey() + ChatColor.GRAY + ", ");
								else sb.append(ChatColor.GOLD + "-" + ChatColor.YELLOW + e.getKey() + ChatColor.GRAY + ", ");
							sb.deleteCharAt(sb.length() - 1);
							sb.deleteCharAt(sb.length() - 1);
							sb.deleteCharAt(sb.length() - 1);
							sb.deleteCharAt(sb.length() - 1);
							perms = sb.toString();
						}
						String subgroups = null;
						if (!gp.getInheritances().isEmpty()) {
							StringBuffer sb = new StringBuffer();
							for (String e : gp.getInheritances())
								sb.append(e + ", ");
							sb.deleteCharAt(sb.length() - 1);
							sb.deleteCharAt(sb.length() - 1);
							subgroups = sb.toString();
						}
						
						if (perms != null) s.sendMessage(plugin.stag + plugin.format("group.list.perms.perms", args[0], perms));
						else s.sendMessage(plugin.stag + plugin.format("group.list.perms.noperms", args[0]));
						if (subgroups != null) s.sendMessage(plugin.stag + plugin.format("group.list.perms.inheritances", args[0], subgroups));
						else s.sendMessage(plugin.stag + plugin.format("group.list.perms.noinheritances", args[0]));
					} else s.sendMessage(plugin.errtag + plugin.format("group.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void groups(Player s) {
				if (!s.hasPermission("mauperms.group.list.groups")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					if (pm.getGroups().isEmpty()) s.sendMessage(plugin.errtag + plugin.format("group.list.nogroups"));
					else {
						StringBuffer sb = new StringBuffer();
						for (String ss : pm.getGroups())
							sb.append(ss + ", ");
						sb.deleteCharAt(sb.length() - 1);
						sb.deleteCharAt(sb.length() - 1);
						s.sendMessage(plugin.stag + plugin.format("group.list", sb.toString()));
					}
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
		}
		
		protected class Del {
			protected void perm(Player s, String cmd) {
				if (!s.hasPermission("mauperms.group.del.permission")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					GroupPerms gp = pm.getGroup(args[0]);
					if (gp != null) {
						String perm = args[1];
						if (args[1].startsWith("-")) perm = perm.substring(1);
						if (gp.removePermission(perm)) {
							pm.setGroup(args[0], gp);
							s.sendMessage(plugin.stag + plugin.format("group.del.perm", args[1], args[0]));
						} else s.sendMessage(plugin.stag + plugin.format("group.del.perm.failed", args[1], args[0]));
					} else s.sendMessage(plugin.errtag + plugin.format("group.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void chatformat(Player s, String cmd) {
				if (!s.hasPermission("mauperms.group.del.chatformat")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					GroupPerms gp = pm.getGroup(args[0]);
					if (gp != null) {
						gp.setChatFormat("");
						pm.setGroup(args[0], gp);
						s.sendMessage(plugin.stag + plugin.format("group.del.chatformat", args[0]));
					} else s.sendMessage(plugin.errtag + plugin.format("group.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void inheritance(Player s, String cmd) {
				if (!s.hasPermission("mauperms.group.del.inheritance")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					GroupPerms gp = pm.getGroup(args[0]);
					if (gp != null) {
						if (gp.removeInheritance(args[1])) {
							pm.setGroup(args[0], gp);
							s.sendMessage(plugin.stag + plugin.format("group.del.inheritance", args[0], args[1]));
						} else s.sendMessage(plugin.stag + plugin.format("group.del.inheritance.failed", args[0], args[1]));
					} else s.sendMessage(plugin.errtag + plugin.format("group.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void group(Player s, String cmd) {
				if (!s.hasPermission("mauperms.group.del.group")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					if (pm.removeGroup(args[0])) s.sendMessage(plugin.stag + plugin.format("group.del", args[0]));
					else s.sendMessage(plugin.errtag + plugin.format("player.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
		}
		
		protected class Add {
			protected void def(Player s, String cmd) {
				if (!s.hasPermission("mauperms.group.add.default")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					PermissionManager pm = PermissionManager.getInstance();
					pm.setDefaultGroup(cmd);
					s.sendMessage(plugin.stag + plugin.format("group.add.default", pm.getDefaultGroup()));
				} catch (Exception e) {
					e.printStackTrace();
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void perm(Player s, String cmd) {
				if (!s.hasPermission("mauperms.group.add.permission")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					GroupPerms gp = pm.getGroup(args[0]);
					if (gp != null) {
						String perm = args[1];
						boolean enabled = true;
						if (args[1].startsWith("-")) {
							perm = perm.substring(1);
							enabled = false;
						}
						if (gp.addPermission(perm, enabled)) {
							pm.setGroup(args[0], gp);
							s.sendMessage(plugin.stag + plugin.format("group.add.perm", args[1], args[0]));
						} else s.sendMessage(plugin.stag + plugin.format("group.add.perm.failed", args[1], args[0]));
					} else s.sendMessage(plugin.errtag + plugin.format("group.notfound", args[0]));
				} catch (Exception e) {
					e.printStackTrace();
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void chatformat(Player s, String cmd) {
				if (!s.hasPermission("mauperms.group.add.chatformat")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ", 2);
					GroupPerms gp = pm.getGroup(args[0]);
					if (gp != null) {
						gp.setChatFormat(args[1]);
						pm.setGroup(args[0], gp);
						s.sendMessage(plugin.stag + plugin.format("group.add.chatformat", args[0], args[1]));
					} else s.sendMessage(plugin.errtag + plugin.format("group.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void inheritance(Player s, String cmd) {
				if (!s.hasPermission("mauperms.group.add.inheritance")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					GroupPerms gp = pm.getGroup(args[0]);
					if (gp != null) {
						if (gp.addInheritance(args[1])) {
							pm.setGroup(args[0], gp);
							s.sendMessage(plugin.stag + plugin.format("group.add.inheritance", args[0], args[1]));
						} else s.sendMessage(plugin.stag + plugin.format("group.add.inheritance.failed", args[0], args[1]));
					} else s.sendMessage(plugin.errtag + plugin.format("group.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void group(Player s, String cmd) {
				if (!s.hasPermission("mauperms.group.add.group")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					if (pm.containsGroup(args[0])) s.sendMessage(plugin.errtag + plugin.format("group.add.exists", pm.fixCase(args[0])));
					else {
						pm.setGroup(args[0], new GroupPerms());
						s.sendMessage(plugin.stag + plugin.format("group.add", args[0]));
					}
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
		}
	}
	
	protected class PlayerCmds {
		protected Add add;
		protected Del del;
		protected List list;
		
		protected PlayerCmds() {
			add = new Add();
			del = new Del();
			list = new List();
		}
		
		protected class List {
			protected void perms(Player s, String cmd) {
				if (!s.hasPermission("mauperms.player.list.permissions")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					Player p = MauBukLib.getUtils().getPlayer(args[0]);
					if (p != null) {
						PlayerPerms pp = pm.getPlayer(p.getUniqueId());
						String perms = null;
						if (!pp.getPermissions().isEmpty()) {
							StringBuffer sb = new StringBuffer();
							for (Entry<String, Boolean> e : pp.getPermissions().entrySet())
								if (e.getValue()) sb.append(ChatColor.YELLOW + e.getKey() + ChatColor.GRAY + ", ");
								else sb.append(ChatColor.GOLD + "-" + ChatColor.YELLOW + e.getKey() + ChatColor.GRAY + ", ");
							sb.deleteCharAt(sb.length() - 1);
							sb.deleteCharAt(sb.length() - 1);
							sb.deleteCharAt(sb.length() - 1);
							sb.deleteCharAt(sb.length() - 1);
							perms = sb.toString();
						}
						String subgroups = null;
						if (!pp.getSubgroups().isEmpty()) {
							StringBuffer sb = new StringBuffer();
							for (String e : pp.getSubgroups())
								sb.append(e + ", ");
							sb.deleteCharAt(sb.length() - 1);
							sb.deleteCharAt(sb.length() - 1);
							subgroups = sb.toString();
						}
						
						s.sendMessage(plugin.stag + plugin.format("player.list.perms.maingroup", p.getName(), pp.getGroup()));
						if (subgroups != null) s.sendMessage(plugin.stag + plugin.format("player.list.perms.subgroups", p.getName(), subgroups));
						if (perms != null) s.sendMessage(plugin.stag + plugin.format("player.list.perms.perms", p.getName(), perms));
						else {
							// s.sendMessage(plugin.stag + plugin.format("player.list.perms.noperms",
							// p.getName()));
						}
						
					} else s.sendMessage(plugin.errtag + plugin.format("player.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
		}
		
		protected class Del {
			protected void perm(Player s, String cmd) {
				if (!s.hasPermission("mauperms.player.del.permission")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					Player p = MauBukLib.getUtils().getPlayer(args[0]);
					if (p != null) {
						String perm = args[1];
						if (args[1].startsWith("-")) perm = perm.substring(1);
						PlayerPerms pp = pm.getPlayer(p.getUniqueId());
						if (pp.removePermission(perm)) {
							pm.setPlayer(p.getUniqueId(), pp);
							s.sendMessage(plugin.stag + plugin.format("player.del.perm", args[1], p.getName()));
						} else s.sendMessage(plugin.stag + plugin.format("player.del.perm.failed", args[1], p.getName()));
					} else s.sendMessage(plugin.errtag + plugin.format("player.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void chatformat(Player s, String cmd) {
				if (!s.hasPermission("mauperms.player.del.chatformat")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					Player p = MauBukLib.getUtils().getPlayer(args[0]);
					if (p != null) {
						PlayerPerms pp = pm.getPlayer(p.getUniqueId());
						pp.setChatFormat("");
						pm.setPlayer(p.getUniqueId(), pp);
						s.sendMessage(plugin.stag + plugin.format("player.del.chatformat", p.getName(), pp.getGroup()));
					} else s.sendMessage(plugin.errtag + plugin.format("player.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void subgroup(Player s, String cmd) {
				if (!s.hasPermission("mauperms.player.del.subgroup")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					Player p = MauBukLib.getUtils().getPlayer(args[0]);
					if (p != null) {
						PlayerPerms pp = pm.getPlayer(p.getUniqueId());
						if (pp.removeSubgroup(args[1])) {
							pm.setPlayer(p.getUniqueId(), pp);
							s.sendMessage(plugin.stag + plugin.format("player.del.subgroup", p.getName(), args[1]));
						} else s.sendMessage(plugin.stag + plugin.format("player.del.subgroup.failed", p.getName(), args[1]));
					} else s.sendMessage(plugin.errtag + plugin.format("player.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void group(Player s, String cmd) {
				if (!s.hasPermission("mauperms.player.del.group")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					Player p = MauBukLib.getUtils().getPlayer(args[0]);
					if (p != null) {
						PlayerPerms pp = pm.getPlayer(p.getUniqueId());
						pp.setGroup(args[1]);
						pm.setPlayer(p.getUniqueId(), pp);
						
						s.sendMessage(plugin.stag + plugin.format("player.del.group", p.getName(), pm.getDefaultGroup()));
					} else s.sendMessage(plugin.errtag + plugin.format("player.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
		}
		
		protected class Add {
			protected void perm(Player s, String cmd) {
				if (!s.hasPermission("mauperms.player.add.permission")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					Player p = MauBukLib.getUtils().getPlayer(args[0]);
					if (p != null) {
						String perm = args[1];
						boolean enabled = true;
						if (args[1].startsWith("-")) {
							perm = perm.substring(1);
							enabled = false;
						}
						PlayerPerms pp = pm.getPlayer(p.getUniqueId());
						if (pp.addPermission(args[1], enabled)) {
							pm.setPlayer(p.getUniqueId(), pp);
							s.sendMessage(plugin.stag + plugin.format("player.add.perm", args[1], p.getName()));
						} else s.sendMessage(plugin.stag + plugin.format("player.add.perm.failed", args[1], p.getName()));
					} else s.sendMessage(plugin.errtag + plugin.format("player.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void chatformat(Player s, String cmd) {
				if (!s.hasPermission("mauperms.player.add.chatformat")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ", 2);
					Player p = MauBukLib.getUtils().getPlayer(args[0]);
					if (p != null) {
						PlayerPerms pp = pm.getPlayer(p.getUniqueId());
						pp.setChatFormat(args[1]);
						pm.setPlayer(p.getUniqueId(), pp);
						s.sendMessage(plugin.stag + plugin.format("player.add.chatformat", p.getName(), args[1]));
					} else s.sendMessage(plugin.errtag + plugin.format("player.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void subgroup(Player s, String cmd) {
				if (!s.hasPermission("mauperms.player.add.subgroup")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					Player p = MauBukLib.getUtils().getPlayer(args[0]);
					if (p != null) {
						PlayerPerms pp = pm.getPlayer(p.getUniqueId());
						if (pp.addSubgroup(args[1])) {
							pm.setPlayer(p.getUniqueId(), pp);
							s.sendMessage(plugin.stag + plugin.format("player.add.subgroup", p.getName(), args[1]));
						} else s.sendMessage(plugin.stag + plugin.format("player.add.subgroup.failed", p.getName(), args[1]));
					} else s.sendMessage(plugin.errtag + plugin.format("player.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
			
			protected void group(Player s, String cmd) {
				if (!s.hasPermission("mauperms.player.add.group")) {
					s.sendMessage(plugin.errtag + plugin.format("error.permission"));
					return;
				}
				try {
					String[] args = cmd.split(" ");
					Player p = MauBukLib.getUtils().getPlayer(args[0]);
					if (p != null) {
						PlayerPerms pp = pm.getPlayer(p.getUniqueId());
						pp.setGroup(args[1]);
						pm.setPlayer(p.getUniqueId(), pp);
						s.sendMessage(plugin.stag + plugin.format("player.add.group", p.getName(), args[1]));
					} else s.sendMessage(plugin.errtag + plugin.format("player.notfound", args[0]));
				} catch (Exception e) {
					s.sendMessage(plugin.errtag + e.getMessage());
				}
			}
		}
	}
	
}
