package net.maunium.bukkit.MauRandomTP;

import java.util.Random;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Sign;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityDamageEvent.DamageCause;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.metadata.FixedMetadataValue;
import org.bukkit.plugin.java.JavaPlugin;

public class MauRandomTP extends JavaPlugin implements Listener{
	
	String version, name, author, errtag, stag;
	
	@Override
	public void onEnable(){
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		name = this.getDescription().getName();
		author = this.getDescription().getAuthors().get(0);
		stag = "2[a" + name + "2]7 ";
		errtag = "4[c" + name + "4]c ";
		
		this.getServer().getPluginManager().registerEvents(this, this);
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + et + "ms.");
	}
	
	@EventHandler
	public void onSignChange(SignChangeEvent evt){
		if(evt.getLine(0).equalsIgnoreCase("[MauRandomTP]")){
			evt.setLine(0, ChatColor.GREEN + "[MauRandomTP]");
		}
	}
	
	@EventHandler
	public void onPlayerInteract(PlayerInteractEvent evt){
		if(!evt.getAction().equals(Action.RIGHT_CLICK_BLOCK)) return;
		if(!evt.getClickedBlock().getType().equals(Material.WALL_SIGN) && !evt.getClickedBlock().getType().equals(Material.SIGN_POST)) return;
		Sign s = (Sign) evt.getClickedBlock().getState();
		if(!s.getLine(0).equals(ChatColor.GREEN + "[MauRandomTP]")) return;
		World w = getServer().getWorld(s.getLine(1));
		if(w == null){
			evt.getPlayer().sendMessage(errtag + "World not found.");
			return;
		}
		String[] p1 = s.getLine(2).split(", ");
		if(p1.length != 2){
			evt.getPlayer().sendMessage(errtag + "Point 1 is invalid. (Array Size)");
			return;
		}
		int p1x, p1z;
		try{
			p1x = Integer.parseInt(p1[0]);
			p1z = Integer.parseInt(p1[1]);
		} catch (NumberFormatException e){
			evt.getPlayer().sendMessage(errtag + "Point 1 is invalid. (NumberFormatException)");
			return;
		}
		
		String[] p2 = s.getLine(2).split(", ");
		if(p2.length != 2){
			evt.getPlayer().sendMessage(errtag + "Point 2 is invalid. (Array Size)");
			return;
		}
		
		int p2x, p2z;
		try{
			p2x = Integer.parseInt(p1[0]);
			p2z = Integer.parseInt(p1[1]);
		} catch (NumberFormatException e){
			evt.getPlayer().sendMessage(errtag + "Point 2 is invalid. (NumberFormatException)");
			return;
		}
		
		Random r = new Random();
		int x = r.nextInt((p2x - p1x) + 1) + p1x;
		int z = r.nextInt((p2z - p1z) + 1) + p1z;
		evt.getPlayer().teleport(new Location(w, x, 150, z, 0, 0));
		evt.getPlayer().setMetadata("maurandomtpd", new FixedMetadataValue(this, true));
	}
	@EventHandler
	public void onPlayerFall(EntityDamageEvent evt){
		if(evt.getEntity() instanceof Player){
			if(evt.getCause().equals(DamageCause.FALL)){
				if(evt.getEntity().hasMetadata("maurandomtpd")){
					evt.setDamage(0.0);
					evt.getEntity().removeMetadata("maurandomtpd", this);
				}
			}
		}
	}
}
