package net.maunium.bukkit.MauTeams;

import java.util.Map.Entry;
import java.util.UUID;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.metadata.FixedMetadataValue;

import net.maunium.bukkit.MauBukLib.MauUtils;

public class CommandTeam implements CommandExecutor {
	private MauTeams plugin;
	
	public CommandTeam(MauTeams plugin) {
		this.plugin = plugin;
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (!(sender instanceof Player)) {
			sender.sendMessage(plugin.errtag + "You must be in-game to use this command.");
			return true;
		}
		Player p = (Player) sender;
		if (args.length > 0) {
			/* HQ */if (eqic(args[0], "hq", "headquaters")) {
				if (plugin.isInTeam(p)) {
					Location l = plugin.getTeamByPlayer(p).getHQ();
					if (l != null) {
						tp(p, l, plugin.stag + plugin.format("teleport.hq"));
					} else p.sendMessage(plugin.errtag + plugin.format("teleport.hq.notset"));
				} else p.sendMessage(plugin.errtag + plugin.format("notinteam"));
			/* Rally */} else if (eqic(args[0], "rally", "rallypoint", "r", "rp")) {
				if (plugin.isInTeam(p)) {
					Location l = plugin.getTeamByPlayer(p).getRally();
					if (l != null) {
						tp(p, l, plugin.stag + plugin.format("teleport.rally"));
					} else p.sendMessage(plugin.errtag + plugin.format("teleport.rally.notset"));
				} else p.sendMessage(plugin.errtag + plugin.format("notinteam"));
			/* Leave */} else if (eqic(args[0], "leave", "quit")) {
				if (plugin.isInTeam(p)) {
					Team t = plugin.getTeamByPlayer(p);
					int r = t.remove(p);
					if (r == 0) {
						t.broadcast(plugin.stag + plugin.format("team.leave.bc", p.getName()));
						p.sendMessage(plugin.stag + plugin.format("team.leave"));
					} else if (r == 1) p.sendMessage(plugin.errtag + plugin.format("team.leave.cant"));
				}
			/* Chat */} else if (eqic(args[0], "chat", "c")) {
				if (args.length == 1) {
					if (!plugin.isInTeamChat(p)) {
						plugin.addToTeamChat(p);
						p.sendMessage(plugin.stag + plugin.format("chat.enter"));
					} else {
						plugin.removeFromTeamChat(p);
						p.sendMessage(plugin.stag + plugin.format("chat.leave"));
					}
				} else {
					StringBuffer sb = new StringBuffer();
					for (int i = 1; i < args.length; i++) {
						sb.append(args[i]);
						sb.append(" ");
					}
					sb.deleteCharAt(sb.length() - 1);
					String msg = sb.toString();
					plugin.getTeamByPlayer(p).sendChatMessage(p, msg);
				}
			/* SetHQ */} else if (eqic(args[0], "sethq", "setheadquaters", "shq")) {
				if (plugin.isInTeam(p)) {
					Team t = plugin.getTeamByPlayer(p);
					if (t.isOwner(p.getUniqueId()) || t.isManager(p.getUniqueId())) {
						t.setHQ(p.getLocation());
						t.broadcast(plugin.stag + plugin.format("set.hq", p.getName()));
					} else p.sendMessage(plugin.errtag + plugin.format("set.hq.member"));
				} else p.sendMessage(plugin.errtag + plugin.format("notinteam"));
			/* SetRally */} else if (eqic(args[0], "setrally", "setrallypoint", "setrp", "srp")) {
				if (plugin.isInTeam(p)) {
					Team t = plugin.getTeamByPlayer(p);
					if (t.isOwner(p.getUniqueId()) || t.isManager(p.getUniqueId())) {
						t.setRally(p.getLocation());
						t.broadcast(plugin.stag + plugin.format("set.rally", p.getName()));
					} else p.sendMessage(plugin.errtag + plugin.format("set.rally.member"));
				} else p.sendMessage(plugin.errtag + plugin.format("notinteam"));
			/* Disband */} else if (eqic(args[0], "disband", "remove")) {
				if (plugin.isInTeam(p)) {
					Team t = plugin.getTeamByPlayer(p);
					if (t.isOwner(p.getUniqueId())) {
						plugin.removeTeam(t);
						p.sendMessage(plugin.stag + plugin.format("team.disband"));
					} else p.sendMessage(plugin.errtag + plugin.format("team.disband.notowner"));
				} else p.sendMessage(plugin.errtag + plugin.format("notinteam"));
			/* Info */} else if (eqic(args[0], "info", "i")) {
				if (args.length > 1) {
					Team t = plugin.getTeamByName(args[1]);
					if (t != null) teamInfo(p, t);
					else {
						OfflinePlayer op = MauUtils.getOfflinePlayer(args[1]);
						if (op != null) {
							if (op.isOnline()) t = plugin.getTeamByPlayer(op.getPlayer());
							else t = plugin.getTeamByUUID(op.getUniqueId());
							if (t != null) teamInfo(p, t);
							else p.sendMessage(plugin.errtag + plugin.format("notinteam.other", op.getName()));
						} else p.sendMessage(plugin.errtag + plugin.format("info.doesnotexist", args[1]));
					}
				} else if (plugin.isInTeam(p)) {
					Team t = plugin.getTeamByPlayer(p);
					if (t != null) teamInfo(p, t);
					else p.sendMessage(plugin.errtag + plugin.format("notinteam"));
				} else p.sendMessage(plugin.errtag + plugin.format("notinteam"));
			/* List */} else if (eqic(args[0], "list", "l")) {
				StringBuffer sb = new StringBuffer();
				for (Entry<String, Team> t : plugin.getTeams()) {
					sb.append(ChatColor.DARK_AQUA);
					sb.append(t.getValue().getName());
					sb.append(ChatColor.GRAY);
					sb.append(", ");
				}
				if (sb.length() != 0) {
					sb.delete(sb.length() - 4, sb.length());
					p.sendMessage(plugin.stag + plugin.format("list.format", sb.toString()));
				} else p.sendMessage(plugin.errtag + plugin.format("list.noteams"));
			/* Friendly Fire */} else if (eqic(args[0], "friendlyfire", "ff")) {
				Team t = plugin.getTeamByPlayer(p);
				if (t != null) {
					if (t.isOwner(p.getUniqueId()) || t.isManager(p.getUniqueId())) {
						if (t.isFriendlyFireOn()) {
							t.setFriendlyFire(false);
							t.broadcast(plugin.stag + plugin.format("team.ff.off", p.getName()));
						} else {
							t.setFriendlyFire(true);
							t.broadcast(plugin.stag + plugin.format("team.ff.on", p.getName()));
						}
					} else p.sendMessage(plugin.errtag + plugin.format("team.ff.member"));
				} else p.sendMessage(plugin.errtag + plugin.format("notinteam"));
			} else if (args.length > 1) {
				/* Create */if (eqic(args[0], "create", "make")) {
					if (!plugin.isInTeam(p)) {
						if (plugin.hasTeam(args[1])) p.sendMessage(plugin.errtag + plugin.format("team.create.exists", args[1]));
						else {
							plugin.addTeam(p, args[1]);
							p.sendMessage(plugin.stag + plugin.format("team.created", args[1]));
						}
					} else p.sendMessage(plugin.errtag + plugin.format("inteam"));
				/* Join */} else if (eqic(args[0], "join", "j")) {
					if (!plugin.isInTeam(p)) {
						Team t = plugin.getTeamByName(args[1]);
						if (t != null) {
							if (t.hasPassword()) {
								if (args.length > 2) {
									if (t.isCorrectPassword(args[2])) {
										t.broadcast(plugin.stag + plugin.format("team.join.bc", p.getName()));
										t.add(p);
										p.sendMessage(plugin.stag + plugin.format("team.join", t.getName()));
									} else p.sendMessage(plugin.errtag + plugin.format("team.join.password.wrong"));
								} else p.sendMessage(plugin.errtag + plugin.format("team.join.password.notgiven", t.getName()));
							} else {
								t.broadcast(plugin.stag + plugin.format("team.join.bc", p.getName()));
								t.add(p);
								p.sendMessage(plugin.stag + plugin.format("team.join", t.getName()));
							}
						} else p.sendMessage(plugin.errtag + plugin.format("team.join.notfound", args[1]));
					} else p.sendMessage(plugin.errtag + plugin.format("inteam"));
				/* Kick */} else if (eqic(args[0], "kick")) {
					if (plugin.isInTeam(p)) {
						Team t = plugin.getTeamByPlayer(p);
						if (t.isOwner(p.getUniqueId()) || t.isManager(p.getUniqueId())) {
							OfflinePlayer op = MauUtils.getOfflinePlayer(args[1]);
							if (op != null) {
								if (t.isPartOfTeam(op.getUniqueId())) {
									if (t.isMember(op.getUniqueId())) {
										if (t.isOwner(p.getUniqueId()) || t.isManager(p.getUniqueId())) {
											if (op.isOnline()) t.remove(op.getPlayer());
											else t.remove(op.getUniqueId());
											t.broadcast(plugin.stag + plugin.format("team.kick", op.getName(), p.getName()));
										} else t.broadcast(plugin.errtag + plugin.format("team.kick.cant"));
									} else if (t.isManager(op.getUniqueId())) {
										t.demote(op.getUniqueId());
										if (op.isOnline()) t.remove(op.getPlayer());
										else t.remove(op.getUniqueId());
										t.broadcast(plugin.stag + plugin.format("team.kick", op.getName(), p.getName()));
									} else t.broadcast(plugin.errtag + plugin.format("team.kick.cant"));
								} else p.sendMessage(plugin.errtag + plugin.format("player.notpartofteam"));
							} else p.sendMessage(plugin.errtag + plugin.format("player.notfound"));
						} else p.sendMessage(plugin.errtag + plugin.format("team.kick.member"));
					} else p.sendMessage(plugin.errtag + plugin.format("notinteam"));
				/* Password */} else if (eqic(args[0], "password", "pass", "p", "pw")) {
					if (plugin.isInTeam(p)) {
						Team t = plugin.getTeamByPlayer(p);
						if (t.isOwner(p.getUniqueId()) || t.isManager(p.getUniqueId())) {
							if (args[1].equalsIgnoreCase("remove")) {
								t.setPassword(null);
								p.sendMessage(plugin.stag + plugin.format("set.password.removed", args[1]));
							} else {
								t.setPassword(args[1]);
								p.sendMessage(plugin.stag + plugin.format("set.password", args[1]));
							}
						} else p.sendMessage(plugin.errtag + plugin.format("set.password.member"));
					} else p.sendMessage(plugin.errtag + plugin.format("notinteam"));
				/* Promote */} else if (eqic(args[0], "promote")) {
					if (plugin.isInTeam(p)) {
						Team t = plugin.getTeamByPlayer(p);
						if (t.isOwner(p.getUniqueId()) || t.isManager(p.getUniqueId())) {
							Player x = MauUtils.getPlayer(args[1]);
							if (x != null) {
								if (t.isMember(x.getUniqueId())) {
									t.promote(x.getUniqueId());
									t.broadcast(plugin.stag + plugin.format("rank.promoted", x.getName(), p.getName()));
								} else if (t.isManager(x.getUniqueId())) {
									if (t.isOwner(p.getUniqueId())) {
										t.setOwner(x.getUniqueId());
										t.broadcast(plugin.stag + plugin.format("rank.promoted.owner", x.getName()));
									} else p.sendMessage(plugin.errtag + plugin.format("rank.promote.alreadymanager", x.getName()));
								} else if (t.isOwner(x.getUniqueId())) p.sendMessage(plugin.errtag + plugin.format("rank.promote.owner", x.getName()));
								else p.sendMessage(plugin.errtag + plugin.format("rank.notteammember", x.getName()));
							} else p.sendMessage(plugin.errtag + plugin.format("rank.notonline", args[1]));
						} else p.sendMessage(plugin.errtag + plugin.format("team.promote.member"));
					} else p.sendMessage(plugin.errtag + plugin.format("notinteam"));
				/* Demote */} else if (eqic(args[0], "demote")) {
					if (plugin.isInTeam(p)) {
						Team t = plugin.getTeamByPlayer(p);
						if (t.isOwner(p.getUniqueId()) || t.isManager(p.getUniqueId())) {
							Player x = MauUtils.getPlayer(args[1]);
							if (x != null) {
								if (t.isManager(x.getUniqueId())) {
									t.demote(x.getUniqueId());
									t.broadcast(plugin.stag + plugin.format("rank.demoted", x.getName(), p.getName()));
								} else if (t.isMember(x.getUniqueId())) p.sendMessage(plugin.errtag + plugin.format("rank.demote.alreadymember", x.getName()));
								else if (t.isOwner(x.getUniqueId())) p.sendMessage(plugin.errtag + plugin.format("rank.demote.owner", x.getName()));
								else p.sendMessage(plugin.errtag + plugin.format("rank.notteammember", x.getName()));
							} else p.sendMessage(plugin.errtag + plugin.format("rank.notonline", args[1]));
						} else p.sendMessage(plugin.errtag + plugin.format("team.demote.member"));
					} else p.sendMessage(plugin.errtag + plugin.format("notinteam"));
				} else help(p, label);
			} else help(p, label);
		} else help(p, label);
		return true;
	}
	
	private boolean eqic(String s, String... ss) {
		for (String c : ss)
			if (c.equalsIgnoreCase(s)) return true;
		return false;
	}
	
	private void teamInfo(Player p, Team t) {
		StringBuffer sb = new StringBuffer();
		{
			Player x = plugin.getServer().getPlayer(t.getOwner());
			if (x != null) {
				sb.append(ChatColor.DARK_GREEN);
				sb.append("**");
				sb.append(x.getName());
			} else {
				sb.append(ChatColor.DARK_GRAY);
				sb.append("**");
				sb.append(plugin.getServer().getOfflinePlayer(t.getOwner()).getName());
			}
			sb.append(ChatColor.GRAY);
			sb.append(", ");
		}
		
		for (UUID uuid : t.getManagers()) {
			Player x = plugin.getServer().getPlayer(uuid);
			if (x != null) {
				sb.append(ChatColor.DARK_GREEN);
				sb.append("*");
				sb.append(x.getName());
			} else {
				sb.append(ChatColor.DARK_GRAY);
				sb.append("*");
				sb.append(plugin.getServer().getOfflinePlayer(uuid).getName());
			}
			sb.append(ChatColor.GRAY);
			sb.append(", ");
		}
		
		for (UUID uuid : t.getMembers()) {
			Player x = plugin.getServer().getPlayer(uuid);
			if (x != null) {
				sb.append(ChatColor.DARK_GREEN);
				sb.append(x.getName());
			} else {
				sb.append(ChatColor.DARK_GRAY);
				sb.append(plugin.getServer().getOfflinePlayer(uuid).getName());
			}
			sb.append(ChatColor.GRAY);
			sb.append(", ");
		}
		
		sb.delete(sb.length() - 4, sb.length());
		
		p.sendMessage(plugin.stag + plugin.format("info.title", t.getName()));
		p.sendMessage(ChatColor.GRAY + plugin.format("info.password", plugin.format("info." + t.hasPassword())));
		p.sendMessage(ChatColor.GRAY + plugin.format("info.ff", plugin.format("info." + t.isFriendlyFireOn())));
		p.sendMessage(ChatColor.GRAY + plugin.format("info.list.def"));
		p.sendMessage(ChatColor.GRAY + plugin.format("info.list", sb.toString()));
	}
	
	private void help(Player p, String label) {
		p.sendMessage(plugin.stag + plugin.format("help.everyone"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " create <name> - " + ChatColor.GRAY + plugin.format("help.create"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " hq - " + ChatColor.GRAY + plugin.format("help.hq"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " rally - " + ChatColor.GRAY + plugin.format("help.rally"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " info [name] - " + ChatColor.GRAY + plugin.format("help.info"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " list - " + ChatColor.GRAY + plugin.format("help.list"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " join <name> [password] - " + ChatColor.GRAY + plugin.format("help.join"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " leave - " + ChatColor.GRAY + plugin.format("help.leave"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " chat [message] - " + ChatColor.GRAY + plugin.format("help.chat"));
		p.sendMessage(plugin.stag + plugin.format("help.managers"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " sethq - " + ChatColor.GRAY + plugin.format("help.sethq"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " setrally - " + ChatColor.GRAY + plugin.format("help.setrally"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " friendlyfire - " + ChatColor.GRAY + plugin.format("help.ff"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " password <password> - " + ChatColor.GRAY + plugin.format("help.password"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " kick <player> - " + ChatColor.GRAY + plugin.format("help.kick"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " promote <player> - " + ChatColor.GRAY + plugin.format("help.promote"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " demote <player> - " + ChatColor.GRAY + plugin.format("help.demote"));
		p.sendMessage(plugin.stag + plugin.format("help.owners"));
		p.sendMessage(ChatColor.DARK_AQUA + "/" + label + " disband - " + ChatColor.GRAY + plugin.format("help.disband"));
	}
	
	private void tp(Player p, Location l, String s) {
		Team t = plugin.getTeamByPlayer(p);
		for (Entity e : p.getNearbyEntities(12, 12, 12)) {
			if (e instanceof Player) {
				Player x = (Player) e;
				if (x.getUniqueId().equals(p.getUniqueId())) continue;
				Team xt = plugin.getTeamByPlayer(x);
				if (t != null && xt != null && t.equals(xt)) continue;
				p.setMetadata(plugin.tping, new FixedMetadataValue(plugin, true));
				p.sendMessage(plugin.stag + plugin.format("teleport.intime"));
				plugin.getServer().getScheduler().runTaskLater(plugin, new TPRunnable(p, l, s), 200);
				return;
			}
		}
		p.teleport(l);
		p.sendMessage(s);
	}
	
	private class TPRunnable implements Runnable {
		private final Location l;
		private final Player p;
		private final String s;
		
		public TPRunnable(Player p, Location l, String s) {
			this.p = p;
			this.l = l;
			this.s = s;
		}
		
		@Override
		public void run() {
			if (p.hasMetadata(plugin.tping)) {
				p.teleport(l);
				p.sendMessage(s);
			}
		}
	}
}