package net.maunium.bukkit.MauckyBloks;

import java.util.HashMap;
import java.util.Map;

import org.bukkit.Location;
import org.bukkit.configuration.serialization.ConfigurationSerializable;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;

public class EntityEntry extends LuckyEntry implements ConfigurationSerializable {
	public static MauckyBloks plugin;
	private EntityType et;
	private double percentChance;
	
	public EntityEntry(EntityType et, double percentChance) {
		this.et = et;
		this.percentChance = percentChance;
	}
	
	@SuppressWarnings("deprecation")
	public EntityEntry(Map<String, Object> serialized) {
		et = EntityType.fromName(serialized.get("entity").toString());
		
		Object p = serialized.get("chance");
		try {
			this.percentChance = Double.parseDouble(p.toString());
		} catch (NumberFormatException e) {
			throw new IllegalArgumentException("Serialized map doesn't contain the chance.");
		}
	}
	
	@Override
	public Map<String, Object> serialize() {
		Map<String, Object> serialized = new HashMap<String, Object>();
		
		serialized.put("entity", et.toString());
		serialized.put("chance", percentChance);
		
		return serialized;
	}
	
	public ItemEntry valueOf(Map<String, Object> serialized) {
		return new ItemEntry(serialized);
	}
	
	public ItemEntry deserialize(Map<String, Object> serialized) {
		return new ItemEntry(serialized);
	}
	
	@Override
	public void spawn(Location l) {
		Entity e = l.getWorld().spawnEntity(l, et);
	}

	@Override
	public boolean add() {
		return r.nextGaussian() * 100 < percentChance;
	}
}
