package net.maunium.bukkit.MauckyBloks;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.plugin.java.JavaPlugin;

public class MauckyBloks extends JavaPlugin implements Listener {
	public String version;
	private List<LuckyEntry> items;
	public final String name = "MauckyBloks", author = "Tulir293", stag = ChatColor.DARK_GREEN + "[" + ChatColor.GREEN + name + ChatColor.DARK_GREEN + "] "
			+ ChatColor.GRAY, errtag = ChatColor.DARK_RED + "[" + ChatColor.RED + name + ChatColor.DARK_RED + "] " + ChatColor.RED;
	
	@Override
	public void onEnable() {
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		this.saveDefaultConfig();
		
		this.getServer().getPluginManager().registerEvents(this, this);
		
		items = new ArrayList<LuckyEntry>();
		
		for (Object o : getConfig().getList("items"))
			if (o instanceof ItemEntry) items.add((ItemEntry) o);
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + et + "ms.");
	}
	
	@Override
	public void onDisable() {
		long st = System.currentTimeMillis();
		
		this.getConfig().set("items", items);
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " disabled in " + et + "ms.");
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (!(sender instanceof Player)) return false;
		if (args.length > 0) {
			if (args[0].equalsIgnoreCase("item") && args.length > 1) {
				Player p = (Player) sender;
				double i = Double.parseDouble(args[1]);
				items.add(new ItemEntry(p.getItemInHand(), i));
				sender.sendMessage(stag + "Added item in hand with chance " + i + "%");
				return true;
			} else if (args[0].equalsIgnoreCase("entity") && args.length > 2) {
				@SuppressWarnings("deprecation")
				EntityType et = EntityType.fromName(args[1]);
				double i = Double.parseDouble(args[2]);
				items.add(new EntityEntry(et, i));
				sender.sendMessage(stag + "Added entity type " + et.toString() + " with chance " + i + "%");
				return true;
			}
		}
		return false;
	}
	
	@EventHandler
	public void onRightClick(PlayerInteractEvent evt) {
		if (evt.getAction().equals(Action.RIGHT_CLICK_BLOCK) && evt.getClickedBlock().getType().equals(Material.SPONGE)) {
			List<LuckyEntry> e = new ArrayList<LuckyEntry>(items);
			Collections.shuffle(e);
			
			for (LuckyEntry ie : e) {
				if (LuckyEntry.r.nextInt(3) == 0) continue;
				if (ie.add()) {
					ie.spawn(evt.getClickedBlock().getLocation());
					return;
				}
			}
			evt.getClickedBlock().setType(Material.AIR);
		}
	}
}