package net.maunium.bukkit.Mauconomy;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

import org.bukkit.inventory.ItemStack;

public class ItemHandler {
	
	public static String toString(ItemStack i) {
		return mapToString(i.serialize());
	}
	
	public static ItemStack fromString(String s) {
		return ItemStack.deserialize(stringToMap(s));
	}
	
	private static String mapToString(Map<String, Object> map) {
		StringBuilder sb = new StringBuilder();
		for (String key : map.keySet()) {
			if (sb.length() > 0) {
				sb.append("&");
			}
			String value = map.get(key).toString();
			try {
				sb.append((key != null ? URLEncoder.encode(key, "UTF-8") : ""));
				sb.append("=");
				sb.append(value != null ? URLEncoder.encode(value, "UTF-8") : "");
			} catch (UnsupportedEncodingException e) {
				throw new RuntimeException("This method requires UTF-8 encoding support", e);
			}
		}
		return sb.toString();
	}
	
	private static Map<String, Object> stringToMap(String input) {
		Map<String, Object> map = new HashMap<String, Object>();
		String[] nameValuePairs = input.split("&");
		for (String nameValuePair : nameValuePairs) {
			String[] nameValue = nameValuePair.split("=");
			try {
				map.put(URLDecoder.decode(nameValue[0], "UTF-8"), nameValue.length > 1 ? URLDecoder.decode(nameValue[1], "UTF-8") : "");
			} catch (UnsupportedEncodingException e) {
				throw new RuntimeException("This method requires UTF-8 encoding support", e);
			}
		}
		
		return map;
	}
}