package net.maunium.bukkit.Maunnouncer;

import java.util.List;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

public class Maunnouncer extends JavaPlugin{
	
	public String version, name, author, errtag, stag, prefix;
	public int interval;
	public List<String> announcements;
	private AnnouncerThread announcer;
	
	@Override
	public void onEnable(){
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		name = this.getDescription().getName();
		author = this.getDescription().getAuthors().get(0);
		stag = "§2[§a" + name + "§2]§7 ";
		errtag = "§4[§c" + name + "§4]§c ";
		this.saveDefaultConfig();
		
		prefix = getConfig().getString("announce-prefix");
		interval = getConfig().getInt("announce-interval");
		announcements = getConfig().getStringList("announcements");
		
		announcer = new AnnouncerThread(this);
		announcer.start();
		
		long et = System.currentTimeMillis();
		int lt = (int) (et - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + lt + "ms.");
	}
	@Override
	public void onDisable(){
		long st = System.currentTimeMillis();
		
		announcer.stopme();
		
		long et = System.currentTimeMillis();
		int lt = (int) (et - st);
		getLogger().info(name + " v" + version + " by " + author + " disabled in " + lt + "ms.");
	}
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args){
		if(cmd.getName().equalsIgnoreCase("announce") && args.length > 0){
			String message = "";
			for(String s : args){
				message = message + " " + s;
			}
			message = message.replaceAll("&", "§").replaceAll("/br/", "\n");
			for(Player p : getServer().getOnlinePlayers()){
				p.sendMessage(prefix.replaceAll("&", "§") + message);
			}
			return true;
		}
		return false;
	}
}
