package net.maunium.bukkit.MauwnProtect;

import java.util.Random;

import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.metadata.FixedMetadataValue;

import net.maunium.bukkit.MauBukLib.MauBukLib;

public class CommandSpawn implements CommandExecutor {
	private MauwnProtect plugin;
	
	public CommandSpawn(MauwnProtect plugin) {
		this.plugin = plugin;
	}
	
	Random r = new Random();
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (args.length == 1 && sender.hasPermission("mauwnprotect.spawn.others")) {
			Player p = MauBukLib.getUtils().getPlayer(args[0]);
			if (p == null) return true;
			Location l = new Location(plugin.getServer().getWorld("Maunium"), -234.5, 65, -37.5, 180, 0);
			p.teleport(l);
			p.sendMessage(plugin.stag + plugin.format("spawn.byother", sender.getName()));
			if (!p.hasMetadata(plugin.PROTECT_TAG)) {
				p.sendMessage(plugin.stag + plugin.format("spawnprotect.gained"));
				p.setMetadata(plugin.PROTECT_TAG, new FixedMetadataValue(plugin, true));
			}
			sender.sendMessage(plugin.stag + plugin.format("spawn.other", p.getName()));
			return true;
		} else if (sender instanceof Player) {
			Player p = (Player) sender;
			double rad = 25;
			boolean playerNearby = false;
			if (!p.hasMetadata(plugin.PROTECT_TAG)) for (Player e : MauBukLib.getUtils().getPlayers(p.getLocation(), rad))
				if (!e.getUniqueId().equals(p.getUniqueId())) {
					playerNearby = true;
					break;
				}
			Location l = new Location(plugin.getServer().getWorld("Maunium"), -234.5, 65, -37.5, 180, 0);
			if (!playerNearby) {
				p.sendMessage(plugin.stag + plugin.format("spawn.byself"));
				p.teleport(l);
				if (!p.hasMetadata(plugin.PROTECT_TAG)) {
					p.sendMessage(plugin.stag + plugin.format("spawnprotect.gained"));
					p.setMetadata(plugin.PROTECT_TAG, new FixedMetadataValue(plugin, true));
				}
			} else {
				p.sendMessage(plugin.stag + plugin.format("spawn.nearbyplayer", 10));
				int i = r.nextInt();
				plugin.getServer().getScheduler().runTaskLater(plugin, new DelayThread(p, l, i, plugin), 200);
				p.setMetadata(plugin.TPDELAY_TAG, new FixedMetadataValue(plugin, i));
			}
			return true;
		}
		return false;
	}
}
