package net.maunium.bukkit.MauwnProtect;

import java.io.IOException;

import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import net.maunium.bukkit.MauBukLib.I18n;

public class MauwnProtect extends JavaPlugin {
	
	protected String version, name, author, stag, errtag, PROTECT_TAG = "mauwnprotect.spawnprotected", TPDELAY_TAG = "mauwnprotect.tping";
	private I18n i18n;
	
	@Override
	public void onEnable() {
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		name = this.getDescription().getName();
		author = this.getDescription().getAuthors().get(0);
		stag = "2[a" + name + "2]7 ";
		errtag = "4[c" + name + "4]c ";
		if(!this.getDataFolder().exists()) this.getDataFolder().mkdirs();
		
		this.saveResource("mauwnprotect.lang", false);
		try {
			i18n = new I18n(this.getDataFolder(), "mauwnprotect");
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		this.getServer().getPluginManager().registerEvents(new DamageListener(this), this);
		this.getServer().getPluginManager().registerEvents(new MoveListener(this), this);
		this.getServer().getPluginManager().registerEvents(new JoinListener(this), this);
		this.getServer().getPluginManager().registerEvents(new RespawnListener(this), this);
		this.getCommand("spawn").setExecutor(new CommandSpawn(this));
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + et + "ms.");
	}
	
	@Override
	public void onDisable() {
		long st = System.currentTimeMillis();
		
		for(Player p : getServer().getOnlinePlayers()){
			p.removeMetadata(TPDELAY_TAG, this);
		}
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " disabled in " + et + "ms.");
	}
	
	public String format(String s, Object... args){
		return i18n.format(s, args);
	}
}
