package net.maunium.bukkit.NerfThatEnch;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import org.bukkit.Material;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.plugin.java.JavaPlugin;

public class NerfThatEnch extends JavaPlugin implements Listener{
	String version, name, author, errtag, stag;
	Map<Enchantment, Integer> disabled;
	@Override
	public void onEnable(){
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		name = this.getDescription().getName();
		author = this.getDescription().getAuthors().get(0);
		stag = "2[a" + name + "2]7 ";
		errtag = "4[c" + name + "4]c ";
		this.saveDefaultConfig();
		
		disabled = new HashMap<Enchantment, Integer>();
		for(Entry<String, Object> e : getConfig().getConfigurationSection("max-enchant-level").getValues(false).entrySet()){
			Enchantment ench = null;
			Integer lvl = null;
			try{
				ench = Enchantment.getByName(e.getKey());
				lvl = Integer.parseInt("" + e.getValue());
			} catch (Exception ex){
				System.err.println("Error: Entry [" + e.getKey() + ", " + e.getValue() + "] is not valid!");
				continue;
			}
			if(ench == null || lvl == null){
				System.err.println("Error: Entry [" + e.getKey() + ", " + e.getValue() + "] is not valid!");
				continue;
			}
			disabled.put(ench, lvl);
		}
		this.getServer().getPluginManager().registerEvents(this, this);

		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + et + "ms.");
	}
	@Override
	public void onDisable(){
		getLogger().info(name + " v" + version + " by " + author + " disabled.");
	}
	@EventHandler
	public void onInventoryClick(InventoryClickEvent evt){
		ItemStack is = evt.getCurrentItem();
		if(is == null) return;
		if(is.getType().equals(Material.AIR)) return;
		if(!is.hasItemMeta()) return;
		if(is.getItemMeta().getEnchants().isEmpty()) return;
		for(Entry<Enchantment, Integer> e : disabled.entrySet()){
			if(is.containsEnchantment(e.getKey())){
				if(is.getItemMeta().getEnchantLevel(e.getKey()) > e.getValue().intValue()){
					ItemMeta im = is.getItemMeta();
					im.removeEnchant(e.getKey());
					if(e.getValue().intValue() > 0){
						im.addEnchant(e.getKey(), e.getValue(), true);
					}
					is.setItemMeta(im);
					evt.setCurrentItem(is);
				}
			}
		}
	}
}
