package net.maunium.bukkit.NickColors;

import java.util.Locale;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.metadata.FixedMetadataValue;
import org.bukkit.metadata.MetadataValue;
import org.bukkit.plugin.java.JavaPlugin;

public class NickColors extends JavaPlugin implements Listener {
	private final String stag = ChatColor.DARK_GREEN + "[" + ChatColor.GREEN + "NickColors" + ChatColor.DARK_GREEN + "] " + ChatColor.GRAY,
			errtag = ChatColor.DARK_RED + "[" + ChatColor.RED + "NickColors" + ChatColor.DARK_RED + "] " + ChatColor.RED, METATAG = "NickColorsMeta";
			
	@Override
	public void onEnable() {
		long st = System.currentTimeMillis();
		
		saveDefaultConfig();
		getServer().getPluginManager().registerEvents(this, this);
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info("NickColors v" + getDescription().getVersion() + " by Tulir293 enabled in " + et + "ms.");
	}
	
	@Override
	public void onDisable() {
		long st = System.currentTimeMillis();
		
		saveConfig();
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info("NickColors v" + getDescription().getVersion() + " by Tulir293 disabled in " + et + "ms.");
	}
	
	@EventHandler
	public void onPlayerJoin(PlayerJoinEvent evt) {
		String s = "colors." + evt.getPlayer().getUniqueId();
		if (getConfig().contains(s)) {
			String color = getConfig().getString(s);
			if (color == null) return;
			ChatColor cc = ChatColor.valueOf(color.toUpperCase(Locale.ENGLISH));
			evt.getPlayer().setDisplayName(cc + evt.getPlayer().getDisplayName() + ChatColor.RESET);
			evt.getPlayer().setMetadata(METATAG, new FixedMetadataValue(this, cc));
		}
	}
	
	@EventHandler
	public void onPlayerQuit(PlayerQuitEvent evt) {
		if (evt.getPlayer().hasMetadata(METATAG)) {
			String s = "colors." + evt.getPlayer().getUniqueId();
			MetadataValue mv = evt.getPlayer().getMetadata(METATAG).get(0);
			if (mv.value() instanceof ChatColor) getConfig().set(s, ((ChatColor) mv.value()).name());
		}
	}
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (!(sender instanceof Player)) {
			sender.sendMessage(errtag + "You can only change your nick color in-game.");
			return true;
		}
		
		Player p = (Player) sender;
		if (args.length > 0) {
			if (args[0].equalsIgnoreCase("reset") || args[0].equalsIgnoreCase("remove")) {
				p.setDisplayName(p.getName());
				p.removeMetadata(METATAG, this);
				getConfig().set("colors." + p.getUniqueId(), null);
				sender.sendMessage(stag + "Nick color removed.");
			} else {
				ChatColor cc = ChatColor.getByChar(args[0].startsWith("&") && args[0].length() == 2 ? args[0].charAt(1) : args[0].charAt(0));
				if (cc.isColor()) {
					p.setDisplayName(cc + p.getName() + ChatColor.RESET);
					p.setMetadata(METATAG, new FixedMetadataValue(this, cc));
					sender.sendMessage(stag + "Nick color changed to " + cc.name().toLowerCase(Locale.ENGLISH));
				} else sender.sendMessage(errtag + "You can only use colors.");
			}
			return true;
		} else return false;
	}
}