package net.maunium.bukkit.PlayerLauncher;

import java.util.List;
import java.util.Set;

import org.bukkit.Location;
import org.bukkit.block.Block;
import org.bukkit.event.Listener;
import org.bukkit.metadata.FixedMetadataValue;
import org.bukkit.metadata.MetadataValue;
import org.bukkit.plugin.java.JavaPlugin;

public class PlayerLauncher extends JavaPlugin implements Listener{
	
	String version, name, author, errtag, stag;
	Set<Location> launchers;
	ConfigManager cm;
	ActionLogger logger;
	
	@Override
	public void onEnable(){
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		name = this.getDescription().getName();
		author = this.getDescription().getAuthors().get(0);
		stag = "2[a" + name + "2]7 ";
		errtag = "4[c" + name + "4]c ";
		this.saveDefaultConfig();
		
		cm = new ConfigManager(this);
		cm.loadConfig();
		
		this.getServer().getPluginManager().registerEvents(new PlayerInteractListener(this), this);
		this.getServer().getPluginManager().registerEvents(new PlayerMoveListener(this), this);
		this.getCommand("launcher").setExecutor(new LauncherCommand(this));
		
		long et = System.currentTimeMillis();
		int lt = (int) (et - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + lt + "ms.");
	}
	
	@Override
	public void onDisable(){
		long st = System.currentTimeMillis();
		
		cm.saveConfig();
		
		long et = System.currentTimeMillis();
		int lt = (int) (et - st);
		getLogger().info(name + " v" + version + " by " + author + " disabled in " + lt + "ms.");
	}
	
	public void debugln(Object message){
		if(this.getConfig().getBoolean("debug-enabled")){
			System.out.println(message);
		}
	}
	public void debug(Object message){
		if(this.getConfig().getBoolean("debug-enabled")){
			System.out.print(message);
			
		}
	}

	public double getBlockMetadata(String path, Block b){
		List<MetadataValue> temp = b.getMetadata(path);
		return temp.get(0).asDouble();
	}
	public void setBlockMetadata(String path, double value, Block b){
		b.setMetadata(path, new FixedMetadataValue(this, value));
	}
}
