package org.asokan.Bukkit.PlayerReputation;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

public class PlayerReputation extends JavaPlugin {

	Map<String, Integer> repmap = new HashMap<String, Integer>();
	String stag;

	@Override
	public void onEnable() {
		saveDefaultConfig();
		reloadConfig();
		Map<String, Object> temp = getConfig()
				.getConfigurationSection("repmap").getValues(true);
		for (Entry<String, Object> e : temp.entrySet()) {
			repmap.put(e.getKey(), new Integer(e.getValue().toString()));
		}
		stag = "2[PlayerReputation]f ";
		getLogger().info("PlayerReputation v0.2 by Tulir293 Enabled");
	}

	@Override
	public void onDisable() {
		if (getConfig().getBoolean("print-more-on-save")) {
			for (Entry<String, Integer> e : repmap.entrySet()) {
				getLogger().info(
						"Saving " + e.getKey() + "'s reputation... (" + e.getValue()
								+ ")");
				getConfig().set("repmap." + e.getKey(), e.getValue());
			}
			getLogger()
					.info("To disable this spam, set \"print-more-on-save to false\" in the config");
		} else {
			for (Entry<String, Integer> e : repmap.entrySet()) {
				getConfig().set("repmap." + e.getKey(), e.getValue());
			}
			getLogger().info("Reputation map saved!");
		}
		saveConfig();
		getLogger().info("PlayerReputation v0.2 by Tulir293 Disabled");
	}

	/*
	 * @EventHandler public void onPlayerJoin(PlayerJoinEvent evt) { if
	 * (repmap.containsKey(evt.getPlayer().getName())) {
	 * repmap.put(evt.getPlayer().getName(), 0); } }
	 */

	public boolean onCommand(CommandSender sender, Command cmd, String label,
			String[] args) {
		/*
		 * Check player reputation.
		 */
		if (cmd.getName().toLowerCase().equals("prcheck")) {
			/*
			 * No args; Player checking own reputation.
			 */
			if (args.length == 0 && (sender instanceof Player)) {
				// Check for permissions
				if (!repmap.containsKey(sender.getName())) {
					repmap.put(sender.getName(), 0);
				}
				if (sender.hasPermission("playerrep.check.own")) {
					sender.sendMessage(stag + "Your reputation is "
							+ repmap.get(sender.getName()) + ".");
					getLogger()
							.info(sender.getName()
									+ " requested own reputation; Request complete.");
				} else {
					sender.sendMessage(stag
							+ "4Sorry, I can't let you check your own reputation.");
				}
			}
			else if (args.length == 1 && args[0].toLowerCase().equals("top5")){
				int[] topr = new int[5];
				String[] topn = new String[5];
				for (Entry<String, Integer> e : repmap.entrySet()) {
					if(e.getValue() > topr[4]){
						if(e.getValue() > topr[3]){
							if(e.getValue() > topr[2]){
								if(e.getValue() > topr[1]){
									if(e.getValue() > topr[0]){
										topr[4] = topr[3];
										topr[3] = topr[2];
										topr[2] = topr[1];
										topr[1] = topr[0];
										topr[0] = e.getValue();
										topn[4] = topn[3];
										topn[3] = topn[2];
										topn[2] = topn[1];
										topn[1] = topn[0];
										topn[0] = e.getKey();
									} else {
										topr[4] = topr[3];
										topr[3] = topr[2];
										topr[2] = topr[1];
										topr[1] = e.getValue();
										topn[4] = topn[3];
										topn[3] = topn[2];
										topn[2] = topn[1];
										topn[1] = e.getKey();
									}
								} else {
									topr[4] = topr[3];
									topr[3] = topr[2];
									topr[2] = e.getValue();
									topn[4] = topn[3];
									topn[3] = topn[2];
									topn[2] = e.getKey();
								}
							} else {
								topr[4] = topr[3];
								topr[3] = e.getValue();
								topn[4] = topn[3];
								topn[3] = e.getKey();
							}
						} else {
							topr[4] = e.getValue();
							topn[4] = e.getKey();
						}
					}
				}
				sender.sendMessage(stag + "1. " + topn[0] + " with " + topr[0] + " reputation!");
				sender.sendMessage(stag + "2. " + topn[1] + " with " + topr[1] + " reputation!");
				sender.sendMessage(stag + "3. " + topn[2] + " with " + topr[2] + " reputation!");
				sender.sendMessage(stag + "4. " + topn[3] + " with " + topr[3] + " reputation!");
				sender.sendMessage(stag + "5. " + topn[4] + " with " + topr[4] + " reputation!");
				getLogger().info(sender.getName() + " requested the top 5 list; Request complete!");
			}
			else if (args.length == 1 && args[0].toLowerCase().equals("average")){
				int totalrep = 0;
				int amountofplayers = 0;
				int average = 0;
				for (Entry<String, Integer> e : repmap.entrySet()) {
					totalrep += e.getValue();
					amountofplayers++;
				}
				average = totalrep / amountofplayers;
				sender.sendMessage(stag + "Average reputation on this server: " + average);
				getLogger().info(sender.getName() + " requested average reputation; Request complete.");
			}
			/*
			 * One arg; Check a players reputation.
			 */
			else if (args.length == 1) {
				if (!repmap.containsKey(args[0])) {
					repmap.put(args[0], 0);
				}
				// Check for permissions
				if (sender.hasPermission("playerrep.check.others")) {
					sender.sendMessage(stag + args[0] + "'s reputation is "
							+ repmap.get(args[0]));
					getLogger().info(
							sender.getName() + " requested " + args[0]
									+ "'s reputation; Request complete.");
				} else {
					sender.sendMessage(stag
							+ "4Sorry, I can't let you check other players' repmap. Try /prcheck");
				}
			} else {
				sender.sendMessage(stag + "Usage: /prcheck <playername>");
			}
			return true;
		}
		/*
		 * Modify player reputation
		 */
		else if (cmd.getName().toLowerCase().equals("prmodify")) {
			if (args.length == 3) {
				/*
				 * Rename/Declare needed variables.
				 */
				int os;
				String pn = args[0];
				Boolean pio = false;
				Player p = getServer().getPlayer(args[0]);
				String ids = args[1].toLowerCase();
				int amount = Integer.parseInt(args[2]);
				int maxamount = getConfig().getInt("max-modify");
				int maxreputation = getConfig().getInt("max-reputation");
				int minreputation = getConfig().getInt("min-reputation");
				/*
				 * Check and modify some stuff
				 */
				if (!repmap.containsKey(pn)) {
					repmap.put(pn, 0);
					os = 0;
				} else {
					os = repmap.get(pn);
				}
				if (!ids.equals("set") && amount > maxamount) {
					amount = maxamount;
					sender.sendMessage(stag
							+ "4Warning: Change amount decreased to "
							+ maxamount + " caused by the configuration.");
				}
				if ((os + amount) > maxreputation) {
					sender.sendMessage(stag
							+ "4Error: You can't have a higher reputation than "
							+ maxreputation + " because of the configuration.");
					return true;
				}
				if ((os - amount) < minreputation) {
					sender.sendMessage(stag
							+ "4Error: You can't have a lower reputation than "
							+ minreputation + " because of the configuration.");
					return true;
				}
				if (p != null) {
					pio = true;
				}
				/*
				 * Do the actual things.
				 */
				if (ids.equals("inc")) {
					if (sender.hasPermission("playerrep.modify.inc")) {
						Integer ns = repmap.get(pn) + amount;
						repmap.put(pn, ns);
						sender.sendMessage(stag + "Increased " + pn
								+ "'s reputation by " + amount + ". (Old reputation: "
								+ os + ")");
						getLogger().info(
								sender.getName() + " increased " + pn
										+ "'s reputation by " + amount
										+ ". (Old reputation: " + os + ")");
						if (pio) {
							p.sendMessage(stag
									+ "Your reputation has been increased by "
									+ amount + " by " + sender.getName()
									+ ". (Old reputation: " + os + ")");
						}
					} else {
						sender.sendMessage(stag
								+ "4Sorry, I can't let you increase repmap.");
					}
				} else if (ids.equals("dec")) {
					if (sender.hasPermission("playerrep.modify.dec")) {
						Integer ns = repmap.get(pn) - amount;
						repmap.put(pn, ns);
						sender.sendMessage(stag + "Decreased " + pn
								+ "'s reputation by " + amount + ". (Old reputation: "
								+ os + ")");
						getLogger().info(
								sender.getName() + " decreased " + pn
										+ "'s reputation by " + amount
										+ ". (Old reputation: " + os + ")");
						if (pio) {
							p.sendMessage(stag
									+ "Your reputation has been decreased by "
									+ amount + " by " + sender.getName()
									+ ". (Old reputation: " + os + ")");
						}
					} else {
						sender.sendMessage(stag
								+ "4Sorry, I can't let you decrease repmap.");
					}
				} else if (ids.equals("set")) {
					if (sender.hasPermission("playerrep.modify.set")) {
						repmap.put(pn, amount);
						sender.sendMessage(stag + "Set " + pn + "'s reputation to "
								+ amount + ". (Old reputation: " + os + ")");
						getLogger().info(
								sender.getName() + " set " + pn
										+ "'s reputation to " + amount
										+ ". (Old reputation: " + os + ")");
						if (pio) {
							p.sendMessage(stag + "Your reputation has been set to "
									+ amount + " by " + sender.getName()
									+ ". (Old reputation: " + os + ")");
						}
					} else {
						sender.sendMessage(stag
								+ "4Sorry, I can't let you set repmap.");
					}
				} else {
					sender.sendMessage(stag
							+ "Usage: /prmodify <playername> <inc/dec/set> <amount>");
				}
			} else {
				sender.sendMessage(stag
						+ "Usage: /prmodify <playername> <inc/dec/set> <amount>");
			}
			return true;
		}
		/*
		 * Data command
		 */
		else if (getConfig().getBoolean("allow-commands-that-might-fail")) {
			if (cmd.getName().toLowerCase().equals("prdata")) {
				if (sender.hasPermission("playerrep.data")) {
					if (args.length == 1) {
						if (args[0].toLowerCase().equals("save")) {
							if (getConfig().getBoolean("print-more-on-save")) {
								for (Entry<String, Integer> e : repmap
										.entrySet()) {
									getLogger().info(
											"Saving " + e.getKey()
													+ "'s reputation... ("
													+ e.getValue() + ")");
									getConfig().set("repmap." + e.getKey(),
											e.getValue());
								}
								getLogger()
										.info("To disable this spam, set \"print-more-on-save to false\" in the config");
							} else {
								for (Entry<String, Integer> e : repmap
										.entrySet()) {
									getConfig().set("repmap." + e.getKey(),
											e.getValue());
								}
								getLogger().info("Reputation map saved!");
							}
							saveConfig();
							sender.sendMessage(stag + "Data saved!");
						} else if (args[0].toLowerCase().equals("load")) {
							reloadConfig();
							Map<String, Object> temp = getConfig()
									.getConfigurationSection("players")
									.getValues(true);
							for (Entry<String, Object> e : temp.entrySet()) {
								System.out.println(e.getValue().toString());
								repmap.put(e.getKey(), new Integer(e.getValue()
										.toString()));
							}
							stag = "2[PlayerReputation] ";
							sender.sendMessage(stag
									+ "Data reloaded from config!");
						} else {
							sender.sendMessage(stag
									+ "Usage: /prdata <save/reload>");
						}
					} else {
						sender.sendMessage(stag
								+ "Usage: /prdata <save/reload>");
					}
					return true;
				} else {
					sender.sendMessage(stag
							+ "4Sorry, I can't let you save/load data.");
				}
			}
		} else {
			sender.sendMessage(stag
					+ "4Error: Commands that might fail have been disabled from config. Use /reload instead.");
		}
		return false;
	}
}
