package net.maunium.bukkit.SpawnThatDragon;

import java.util.Random;

import org.bukkit.Bukkit;
import org.bukkit.Effect;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.metadata.FixedMetadataValue;
import org.bukkit.plugin.java.JavaPlugin;

public class STDMain extends JavaPlugin implements Listener{
	
	private String version, name, author;
	private int maxHits, minHits, timeTH;
	private boolean smoke, fire;
	
	@Override
	public void onEnable(){
		long st = System.currentTimeMillis();
		version = this.getDescription().getVersion();
		name = this.getDescription().getName();
		author = this.getDescription().getAuthors().get(0);
		this.saveDefaultConfig();
		this.getServer().getPluginManager().registerEvents(this, this);
		
		maxHits = getConfig().getInt("max-hits-to-break");
		minHits = getConfig().getInt("min-hits-to-break");
		timeTH = getConfig().getInt("time-to-hatch");
		smoke = getConfig().getBoolean("smoke-when-breaking");
		fire = getConfig().getBoolean("fire-particles-when-hatching");
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " enabled in " + et + "ms.");
	}
	@Override
	public void onDisable(){
		long st = System.currentTimeMillis();
		
		
		int et = (int) (System.currentTimeMillis() - st);
		getLogger().info(name + " v" + version + " by " + author + " disabled in " + et + "ms.");
	}
	
	@EventHandler
	public void onDragoneggPlace(BlockPlaceEvent evt){
		if(evt.getBlock().getType().equals(Material.DRAGON_EGG)){
			evt.getBlock().setMetadata("isHatchingSTD", new FixedMetadataValue(this, true));
			evt.getBlock().setMetadata("hitsToBreakSTD", new FixedMetadataValue(this, new Random().nextInt(maxHits - minHits) + minHits));
			Bukkit.getScheduler().runTaskAsynchronously(this, new EggHatcher(this, evt.getBlock(), fire, timeTH));
		}
	}
	
	@EventHandler
	public void onDragoneggInteract(PlayerInteractEvent evt){
		Block c = evt.getClickedBlock();
		if(!evt.getAction().equals(Action.RIGHT_CLICK_BLOCK) && !evt.getAction().equals(Action.LEFT_CLICK_BLOCK)) return;
		if(!c.getType().equals(Material.DRAGON_EGG)) return;
		if(evt.getAction().equals(Action.LEFT_CLICK_BLOCK) && evt.getItem() != null){
			if(evt.getItem().getType().toString().toLowerCase().contains("sword")){
				if(c.hasMetadata("isHatchingSTD")){
					if(c.hasMetadata("isBeingBrokenSTD")){
						int newValue = c.getMetadata("isBeingBrokenSTD").get(0).asInt() + 1;
						if(newValue == c.getMetadata("hitsToBreakSTD").get(0).asInt()){
							c.breakNaturally();
							if(smoke){
								for(int i = 0; i < 30; i++) c.getWorld().playEffect(c.getLocation(), Effect.SMOKE, new Random().nextInt(31));
							}
							c.removeMetadata("hitsToBreakSTD", this);
							c.removeMetadata("isBeingBrokenSTD", this);
						} else {
							c.setMetadata("isBeingBrokenSTD", new FixedMetadataValue(this, newValue));
							if(smoke){
								for(int i = 0; i < 5; i++) c.getWorld().playEffect(c.getLocation().add(0, 1, 0), Effect.SMOKE, 31);
							}
						}
					} else {
						c.setMetadata("isBeingBrokenSTD", new FixedMetadataValue(this, 1));
						if(smoke){
							for(int i = 0; i < 5; i++) c.getWorld().playEffect(c.getLocation().add(0, 1, 0), Effect.SMOKE, 31);
						}
					}
				} else {
					c.breakNaturally();
				}
			}
		}
		evt.setCancelled(true);
	}
}
